import { EmberRunTimer } from '@ember/runloop/types';
import Component from '@glimmer/component';
import { LaddaButton as Ladda } from 'ladda';
import LaddaButtonService, { ButtonStyle } from 'ember-ladda-button/services/ladda-button';
declare type Action = (() => void) | (() => Promise<void>);
interface Args {
    action?: Action;
    buttonStyle?: ButtonStyle;
    class?: string;
    disabled?: boolean;
    inFlight?: boolean;
    longAction?: Action;
    longDelay?: number;
    spinnerColor?: string;
    spinnerLines?: number;
    spinnerSize?: number;
    text?: string;
    type?: 'button' | 'reset' | 'submit';
}
export default class LaddaButton extends Component<Args> {
    laddaButton: LaddaButtonService;
    inFlightPromise: boolean;
    ladda: null | Ladda;
    longLater: EmberRunTimer | null;
    longPress: boolean;
    longProgress: number;
    longProgressInterval: number | null;
    previousInFlight: boolean;
    get buttonStyle(): ButtonStyle;
    get disabled(): boolean;
    get inFlight(): boolean;
    get spinnerColor(): string | null;
    get spinnerLines(): number | null;
    get spinnerSize(): number | null;
    get type(): "button" | "reset" | "submit";
    cancelLongTimers(): void;
    clearLongState(): void;
    didInsert(element: HTMLButtonElement): void;
    handleClick(): void;
    handleMouseDown(): void;
    handleMouseLeave(): void;
    updateLoadingState(): void;
    willDestroy(): void;
}
export {};
